self.addEventListener('push', event => {
  const data = event.data.json();

  const options = {
    body: data.notification.body || 'Default Body Message',
    icon: data.notification.icon || 'https://example.com/icon.png',
    image: data.notification.image || 'https://example.com/image.png',
    data: {
      url: data.notification.data.url || 'https://example.com'
    },
    vibrate: [200, 100, 200] 
  };

  event.waitUntil(
    self.registration.showNotification(data.notification.title || 'Default Title', options)
  );
});

self.addEventListener('notificationclick', event => {
  event.notification.close();

  if (event.notification.data && event.notification.data.url) {
    event.waitUntil(
      clients.openWindow(event.notification.data.url)
    );
  }
});
